#!/usr/bin/env python

import os
import sys
import stat
import tempfile

IDA_INSTALL_PATH = '/ida/install/path'
IDA_SCRIPT_PATH = '/ida/script/path'
IDA_OUT_FILE = os.path.join(tempfile.gettempdir(), 'idaout.txt')
TARGET = 'idascript'

if not os.path.isdir(IDA_INSTALL_PATH):
	print "Absolute path to your IDA install directory: ",
	IDA_INSTALL_PATH = sys.stdin.readline().strip()
	print ""

if not os.path.isdir(IDA_SCRIPT_PATH):
	print "Absolute path to the directory where you usually keep all your IDA scripts: ",
	IDA_SCRIPT_PATH = sys.stdin.readline().strip()
	print ""

if sys.platform == 'win32':
	BIN_INSTALL_PATH = os.path.join(IDA_INSTALL_PATH, TARGET)
else:
	try:
		BIN_INSTALL_PATH = os.path.join(os.getenv("PATH").split(':')[0], TARGET)
	except:
		BIN_INSTALL_PATH = '/usr/local/bin/' + TARGET

files = [(os.path.join('src', TARGET), BIN_INSTALL_PATH), (os.path.join('src', TARGET + '.py'), os.path.join(IDA_INSTALL_PATH, 'python', TARGET + '.py'))]

replacements = [('%%IDA_INSTALL_PATH%%', IDA_INSTALL_PATH),
		('%%IDA_SCRIPT_PATH%%', IDA_SCRIPT_PATH),
		('%%IDA_OUT_FILE%%', IDA_OUT_FILE)]

print "BIN_INSTALL_PATH = %s" % BIN_INSTALL_PATH
print "IDA_INSTALL_PATH = %s" % IDA_INSTALL_PATH
print "IDA_SCRIPT_PATH = %s" % IDA_SCRIPT_PATH
print "IDA_OUT_FILE = %s" % IDA_OUT_FILE

for (srcname, dstname) in files:
	data = open(srcname).read()

	for (replaceme, withme) in replacements:
		data = data.replace(replaceme, withme)

	open(dstname, 'w').write(data)
	os.chmod(dstname, (stat.S_IROTH | stat.S_IXOTH | stat.S_IRWXU))

