##################################################################################################
# Python module for IDAPython scripts run via idascript.
#
# Copied from the original idascript utility, with minor changes: http://www.hexblog.com/?p=128
#
# Craig Heffner
# 14-November-2012
# http://www.tacnetsol.com
# http://www.devttys0.com
##################################################################################################

import sys
import idc

class ToFileStdOut(object):
    def __init__(self, outfile):
        self.outfile = open(outfile, 'w')

    def write(self, text):
        self.outfile.write(text)

    def flush(self):
        self.outfile.flush()

    def isatty(self):
        return False

    def __del__(self):
        self.outfile.close()

# Redirect stdout and stderr to the output file
sys.stdout = sys.stderr = ToFileStdOut('%%IDA_OUT_FILE%%')
# Add the user's script directory to the Python path
sys.path.append('%%IDA_SCRIPT_PATH%%')
# Make the normal sys.argv and sys.exit function properly
sys.argv = idc.ARGV
sys.exit = idc.Exit

